***************************************************************************

***************************************************************************

**   M E G A S Q U I R T - 2 0 0 1 - V2.986

**

**   (C) 2002 - B. A. Bowling And A. C. Grippo

**

**   This header must appear on all derivatives of this code.

**

***************************************************************************

***************************************************************************

;MS exp board base code 1.0
; major strip out of MS code
; all that is left is the rpm calculations, A/D, timer section, and flash burn routine the rest is gone.
; now to add in test code.



.header 'MegaSquirt'

;.base 10t

.pagewidth 130

.pagelength 90

;.set simulate



.nolist

	include "gp32.equ"

.list

	org	ram_start

	include "megasquirt.h"





***************************************************************************

**

** Main Routine Here - Initialization and main loop

**

** Note: Org down 128 bytes below the "rom_start" point

**       because of erase bug in bootloader routine

**

** Note: Items commented out after the Start entry point are

**       taken care of in the Boot_R12.asm code

**

***************************************************************************

	org	{rom_start + 128}

Start:

;       *** Note - uncomment this code if you do not use the Bootloader to initilize ***

;        clra

;	sta	copctl

;	mov	#%00000001,config2

;	mov	#%00001001,config1

;	mov	#%00000001,config1

;	ldhx	#ram_last+1		; Set the stack Pointer

;	txs				;  to the bottom of RAM



;PllSet:

;	bclr	BCS,pctl		; Select external Clock Reference

;	bclr	PLLON,pctl		; Turn Of PLL

;	mov	#$02,pctl		; Set P and E Bits

;	mov	#$C0,pmrs		; Set L

;	mov	#$03,pmsh		; Set N (MSB)

;	mov	#$84,pmsl		; Set N (LSB)

;	bset	AUTO,pbwc

;	bset	PLLON,pctl		; Turn back on PLL

;PLLwait:

;        brclr   LOCK,pbwc,PLLwait

;        bset    BCS,pctl







;

;   Set all RAM to known value - for code runaway protection.

;   If there is ever a code runaway, and processor tries

;    executing this as an opcode ($32) then a reset will occur.

;

	ldhx   #ram_start	;Point to start of RAM

ClearRAM:

	lda	#$32		; This is an illegal op-code - cause reset if executed

	sta    ,x		;Set RAM location

	aix    #1		;advance pointer

	cphx   #ram_last+1	;done ?

	bne    ClearRAM		;loop back if not









;ptapue:         equ     $0D                 ; Port A Input Pullup Enable Register
;ptcpue:         equ     $0E                 ; Port C Input Pullup Enable Register
;ptdpue:         equ     $0F       

; Set up the port data-direction registers

        lda     #%00000000

        sta     ddrb                   ; Set as inputs (ADC will select which channel later)

        lda     #%00110000             ; Turn off injectors (inverted output)

        sta     portd

        lda     #%11110000

        sta     ddrd                 ; Outputs for injector
        
        lda     #%00001111
        
        sta     ptdpue

        clr     porta

        lda     #%11111111

        sta     ddra                   ; set port A bits = all outputs

        lda     #%00000000             ; set porta bit7 for internal pullup resistor

        sta     ptapue

        lda     #$00             ; ** Was 11111111

        sta     ddrc                   ; Outputs for LED
        
        lda     #$1F                   
        
        sta     ptcpue                  ; enable input pull up resistors

        lda     #%00000001             ; Serial Comm Port

        sta     ddre



; Set up the Real-time clock Timer (TIM2)

        MOV     #Timerstop,t2sc        ; Stop Timer so it can be set up

        mov     #$00,T2MODH

        mov     #$B8,T2MODL            ; set timer modulus register to 184 decimal

        mov     #T2SC0_No_PWM,T2SC0    ; make this normal port output (PWM MODE is #$5E)

        mov     #$00,T2CH0H

        mov     #$00,T2CH0L

        MOV     #Timergo,T2SC          ;  set timer prescaler to divide by 4



; Set up the PWM for the Injector (for current limit mode)

        MOV     #Timerstop,t1sc        ; Stop Timer so it can be set up

        mov     #$00,T1MODH

        mov     #$64,T1MODL            ; set timer modulus register to 100 decimal

        mov     #T1SCX_NO_PWM,T1SC0    ; make this normal port output (PWM MODE is #$5E)

        mov     #T1SCX_NO_PWM,T1SC1    ; make this normal port output (PWM MODE is #$5E)

        mov     #$00,T1CH0H

        mov     INJPWM,T1CH0L

        mov     #$00,T1CH1H

        mov     INJPWM,T1CH1L





; Set up SCI port

	lda	#$12			; This is 9600 baud w/ the osc frequency selected

	sta	scbr

	bset	ensci,scc1		; Enable SCI

	bset	RE,SCC2			; Enable receiver

        bset    SCRIE,SCC2              ; Enable Receive interrupt

	lda	SCS1			; Clear SCI transmitter Empty Bit

        clr     txcnt

        clr     txgoal



; Set up Interrupts

        mov     #%00000100,INTSCR	;Enable IRQ







; Set up RAM Variable

        clr     mms

        clr     ms

        clr     tenth

        clr     secl

        clr     sech

        lda     #$FF

   ;     clr     squirt

    ;    lda     #$32

        sta     pw

        clr     engine

        clr     rpmph

        clr     rpmch

        clr     rpm

	clr	old_rpm1

	clr	flocker

        lda     #$00

        sta     pwcalc

        sta     pw

        clr     pwrun1

        clr     pwrun2

        lda     #$FF

        sta     last_tps

        clr     egocount

      ;  clr     fanctrl

        lda     #$BB

        sta     baro

        sta     map

        sta     mat

        sta     clt

        sta     tps

        sta     batt



  ;      lda     #$64

 ;       sta     aircor

 ;       sta     vecurr

 ;       sta     barocor

 ;       sta     warmcor

 ;       sta     egocorr

;	sta	tpsfuelcut

 ;       clr     gammae

        lda     #$46

        sta     map

        lda     #$65

        sta     baro

;	clr	tpsaccel

;        clr     igncount

        ;                                fan control temperatures below
        lda     #$F5            ; 205 deg f NOTE ADD 40 TO DESIRED COOLANT TEMP << was 195
        sta     fan_temp_slow_on
        lda     #$FA            ; 210 deg f
        sta     fan_temp_high_on
        lda     #$f0           ; 200 deg F  <<<< was 197
        sta     fan_temp_high_off
        lda     #$EC            ; 196 deg f  <<< was 188
        sta     fan_temp_off

        lda     #0;
      ;  sta     accelpoint;




; Fire up the ADC, and perform one conversion to get the baro value

	lda	#%01110000	; Set up divide 8 and internal bus clock source

	sta	adclk

	lda	#%00000000	; Select one conversion, no interrupt, AD0

	sta	adscr

	brclr   coco,adscr,*	; wait until conversion is finished



	lda	adr

	sta	baro		; Store value in Barometer





	clr	adsel		; Clear the channel selector



TURN_ON_INTS:

        cli		; Turn on all interrupts now



; Load the constants (VE Table, etc) from Flash to RAM - the program uses the RAM values



        clrh

        clrx

XXVV:

        lda     VETABLE,x       ; This is the FLASH table for all inputs

        sta     VE,x            ; This is the RAM-based table - this is what is used by pgm.

        incx

        cbeqx  #$80,XXXV

        bra    XXVV

XXXV:







; Load the Flash Programming Routine into RAM - it will sit there until invoked



        clrh

        clrx

NEXTRAM:

        lda    ERASE_N_BURN,x   ; Programmer routine to be copied

        sta    BURNER,x         ; RAM Location that keep the burner code

        incx

        cbeqx  #$FF,DONE_LOAD_BURN

        bra    NEXTRAM



DONE_LOAD_BURN:







***************************************************************************

********************    M A I N  E V E N T  L O O P     *******************

***************************************************************************



LOOPER:



********************** test code **************
* set a bit and check if an        
        
        
        ;brset   aircon,fanctrl,FAN_AC1  FAN4    bclr    1,fanctrl       ; clear flag
        
        brset 3,portc,test0
        bset  7,porta
        bra   test1
test0   bclr  7,porta
test1   brset 4,portc,test2
        bset  6,porta
        bra  test3
test2   bclr  6,porta
test3   brset 2,portd,test4
        bset  5,porta
        bra   test5
test4   bclr  5,porta
test5   brset 3,portd,test6
        bset  4,porta
        bra   test7
test6   bclr  4,porta
test7   brset 0,portc,test8
        bset  3,porta
        bra   test9
test8   bclr  3,porta
test9   brset 1,portc,test10
        bset  2,porta
        bra test11
test10  bclr  2,porta
test11  brset 2,portc,test12
        bset  5,portd
        bra  test13
test12  bclr  5,portd
test13  nop


***************************************************************************

**

**  Correction Factor Lookup Table Access

**

**   Perform table lookup for barometer and air density correction factors,

**    and performs coolant temperature conversion from counts to degrees F

**

**   All tables are pre-computed for all 256 different values

**    and stored in FLASH

**

**   Note: Coolant temperature is in degrees F plus 40 - this allows

**    unsigned numbers for full temperature range

**

**

***************************************************************************



        clrh

TurboMap:

        lda     baro

        tax

        lda     BAROFAC4250,x

        sta     tmp11           ; Barometer Correction Gamma



        lda     map

        tax

        lda     KPAFACTOR4250,x

        sta     kpa             ; Manifold Air Pressure in Kilopascals



TurboBaroUse:

	lda	tmp11			; Use the saved MAP-derived barometer value

	sta	barocor





CltCalc:

        lda     clt

        tax

        lda     THERMFACTOR,x

        sta     coolant         ; Coolant temperature in degrees F + 40



        lda     mat

        tax

        lda     AIRDENFACTOR,x

        sta     aircor          ; Air Density Correction Factor






***************************************************************************

**

** Computation of RPM

**

**   rpmk:rpmk+1

**   ----------- = rpm

**   rpmph:rpmpl

**

**  rpmk:rpmK+1 = RPM constant = (6,000 * (stroke/2))/ncyl

**  rpmph:rpmpl = period count between IRQ pulsed lines, in 0.1 millisecond resolution

**

****************************************************************************

RPM_COMP:



        brclr   running,engine,LOOPER

	ldhx    rpmph

        beq     LOOPER



        pshh

        pula

        tsta

        beq        FAST_RPM_CALC



SLOW_RPM_CALC:

        clr       intacc1

        clr       intacc1+1



        sthx      intacc2



        ldhx      rpmk

        sthx      intacc1+2



        jsr       udvd32              ; 32 x 32 divide

        lda       intacc1+3           ; get 8-bit RPM result

        bra       RPM_CALC_DONE



FAST_RPM_CALC:

        lda       rpmk

        psha

        pulh

        lda       rpmk+1

        div                           ; A = (H:A) / X



RPM_CALC_DONE:

        sta       rpm

    

  jmp       LOOPER       ; orginal end of main event



***************************************************************************

**

** * * * * Interrupt Section * * * * *

**

** Following interrupt service routines:

**  - Timer Overflow

**  - ADC Conversion Complete

**  - IRQ input line transistion from high to low

**  - Serial Communication received character

**  - Serial Communications transmit buffer empty (send another character)

**

***************************************************************************







***************************************************************************

**

** Timer Rollover - Occurs every 1/10 of a millisecond - main timing clock

**

**

** Generate time rates:

**  1/10 milliseconds

**  1 milliseconds

**  1/10 seconds

**  seconds

**

** Also, in 1/10 millisecond section, turn on/off injector and

**  check RPM for stall condition

** In milliseconds section, fire off ADC conversion for next channel (5 total),

**  and wrap back when all channels done

**

***************************************************************************



TIMERROLL:

;==========================================================================

;***************** 0.1 millesecond section ********************************

;==========================================================================

        inc      mms		; bump up 0.1 millisec variable


;=======Check RPM Section=====


CHK_RE_ENABLE:

;====== Check for re-enabling of IRQ input pulses





        lda      rpmph          ; Get high byte of last rpm interval

        beq      RPMLOWBYTECHK  ; If zero go ahead check for half interval

        lda      rpmcl          ; Check current rpm interval

        cmp      #128T          ; 12.8 milliseconds is maximum (half of 25.6 ms = 1 in rpmph)

        beq      REARM_IRQ      ; time to re-arm IRQ

        bra      INCRPMER       ; Jump around rpm half interval check





RPMLOWBYTECHK:

	lda	 rpmpl	     	; Load in the latched previous RPM value

        lsra

	cmp	 rpmcl	        ; Is it the same value as current RPM Counter?

	bne	 INCRPMER	; If not then jump around this



REARM_IRQ:

	bset	 ACK,INTSCR	; clear out any latched interrupts

	bclr	 IMASK,INTSCR	; enable interrupts again for IRQ



INCRPMER:

        inc      rpmcl

        bne      CHECK_MMS

        inc      rpmch

        lda      rpmch

        cmp      #$64           ; If RPMPH is 100 (or RPMPeriod = 2.5 sec) then engine stalled

        bne      CHECK_MMS





        clr      rpmch

        clr      rpmcl

        clr      pw             ; zero out pulsewidth

        clr      rpm

	bclr	 IMASK,INTSCR	; enable all IRQ interrupts

	bra	 CHECK_MMS



ENABLE_THE_IRQ:

	bclr	 IMASK,INTSCR   ; Enable IRQ



CHECK_MMS:

        lda      mms

        cmp      #$0A

        bne      RTC_DONE



;==========================================================================

;********************* millesecond section ********************************

;==========================================================================

MSEC:

        inc      ms		; bump up millisec

        clr      mms



; Fire off another ADC conversion, channel is pointed to by ADSEL

	lda	adsel

	ora	#%01000000

	sta	adscr



MSDONE:

        lda      ms

        cmp      #$64

        bne      RTC_DONE



;==========================================================================

;******************** 1/10 second section *********************************

;==========================================================================

ONETENTH:

        inc      tenth

        inc      tpsaclk

        clr      ms



; Save current TPS reading in last_tps variable to ompute TPSDOT in acceleration

;  enrichment section



        lda      tps

        sta      last_tps



        lda      tenth

        cmp      #$0A

        bne      RTC_DONE



;==========================================================================

;********************** seconds section ***********************************

;==========================================================================

SECONDS:



        clr      tenth

        inc      secl		; bump up second count

        bne      RTC_DONE

        inc      sech



RTC_DONE:

	lda      T2SC

	bclr     7,T2SC
                
        rti





***************************************************************************

**

** IRQ - Input trigger for new pulse event

**

** This line is connected to the input trigger (i.e TACH signal from ignition

**  system), and schedules a new injector shot (injector actually opened in

**  1/10 timer section above)

**

***************************************************************************

DOSQUIRT:



;	lda	  igncount

;	bne	  EGOBUMP	; Only increment ase counter if cylinder count is zero

  ;      inc       asecount      ; Increment after-start enrichment counter
;EGOBUMP:

  ;      inc       egocount      ; Increment EGO step counter







        lda       rpmch

        sta       rpmph

        lda       rpmcl

        sta       rpmpl

        clr       rpmch

        clr       rpmcl



       	lda	  rpm


IRQ_EXIT:

	bset	  ACK,INTSCR	; Flush out any new interrupts pending

	bset	  IMASK,INTSCR	; Disable IRQ interrupts

        bset      IRQF,INTSCR

        rti





***************************************************************************

**

** ADC - Interrupt for ADC conversion complete

**

***************************************************************************

ADCDONE:

        pshh            ; Do this because processor does not stack H



        clrh

; Store previous values for derivative

        lda     adsel

        tax

        lda     map,x

        sta     lmap,x  ; Store the old value



	lda	adr     ; Load in the new ADC reading

        add     map,x   ; Perform (map + last_map)/2 averaging (for all ADC readings) - bug fix

        rora

	sta	map,x 	; MAP is entry point, offset is loaded in index register



	lda     adsel

	inca

	cmp	#$06

	bne	ADCPTR

	clra

ADCPTR:

	sta	adsel



        pulh

	rti



***************************************************************************

**

** SCI Communications

**

** Communications is established when the PC communications program sends

** a command character - the particular character sets the mode:

**

** "A" = send all of the realtime variables via txport.

** "V" = send the VE table and constants via txport (128 bytes)

** "W"+<offset>+<newbyte> = receive new VE or constant byte value and

**  store in offset location

** "B" = jump to flash burner routine and burn VE/constant values in RAM into flash

** "C" = Test communications - echo back SECL

** "Q" = Send over Embedded Code Revision Number (divide number by 10 - i.e. $21T is rev 2.1)

**

***************************************************************************

IN_SCI_RCV:

        pshh

        lda     SCS1    ; Clear the SCRF bit by reading this register



        lda     txmode  ; Check if we are in the middle of a receive new VE/constant

        cmp     #$05

        beq     TXMODE_5

        cmp     #$06

        beq     TXMODE_6



        lda     SCDR    ; Get the command byte

        cmp     #$41    ; Is the recieve character a big "A" -> Download real-time variables?

        beq     MODE_A

        cmp     #$42

        beq     MODE_B

        cmp     #$43

        beq     MODE_C

        cmp     #$56

        beq     MODE_V

        cmp     #$57

        beq     MODE_W

	cmp	#$51

	beq	MODE_Q

        bra     DONE_RCV



MODE_A

        clr     txcnt                   ; Send back all real-time variables

        lda     #$01

        sta     txmode

        lda     #$17                    ; change to $18 to send accelpoint

        sta     txgoal

        bset    TE,SCC2                 ; Enable Transmit

        bset    SCTIE,SCC2              ; Enable transmit interrupt

        bra     DONE_RCV



MODE_B:

        mov     #$CC,flocker

        jsr     BURNER

        clr     flocker

        clr     txmode

        bra     DONE_RCV



MODE_C:

        clr     txcnt                   ; Just send back SECL variable to test comm port

        lda     #$01

        sta     txmode

        lda     #$2

        sta     txgoal

        bset    TE,SCC2                 ; Enable Transmit

        bset    SCTIE,SCC2              ; Enable transmit interrupt

        bra     DONE_RCV



MODE_V:

        clr     txcnt

        lda     #$03

        sta     txmode

        lda     #$7E

        sta     txgoal

        bset    TE,SCC2                 ; Enable Transmit

        bset    SCTIE,SCC2              ; Enable transmit interrupt

        bra     DONE_RCV

MODE_W:

        lda     #$05

        sta     txmode

        bra     DONE_RCV



MODE_Q:

        clr     txcnt                   ; Just send back SECL variable to test comm port

        lda     #$05

        sta     txmode

        lda     #$2

        sta     txgoal

        bset    TE,SCC2                 ; Enable Transmit

        bset    SCTIE,SCC2              ; Enable transmit interrupt

        bra     DONE_RCV





TXMODE_5:

        mov     SCDR,rxoffset

        inc     txmode

        bra     DONE_RCV

TXMODE_6:

        clrh

        lda     rxoffset

        tax

        lda     SCDR

        sta     VE,x

        clr     txmode

        bra     DONE_RCV



DONE_RCV

        pulh

        rti





*** Transmit Character Interrupt Handler ***************

IN_SCI_TX:

        pshh

        lda     SCS1    ; Clear the SCRF bit by reading this register

        clrh

        lda     txcnt

        tax

        lda     txmode

	cmp	#$05

	beq	IN_Q_MODE

        cmp     #$01

        bne     IN_V_MODE

IN_A_OR_C_MODE:

        lda     secl,X

        bra     CONT_TX

IN_V_MODE

        lda     ve,x

	bra	CONT_TX

IN_Q_MODE

	lda	REVNUM,X



CONT_TX:

        sta     SCDR

        lda     txcnt

        inca

        sta     txcnt

        cmp     txgoal

        bne     DONE_XFER



        clr     txcnt

        clr     txgoal

        clr     txmode



        bclr    TE,SCC2                 ; Disable Transmit

        bclr    SCTIE,SCC2              ; Disable transmit interrupt



DONE_XFER

        pulh

        rti





***************************************************************************

**

** Dummy ISR - just performs RTS

**

***************************************************************************

Dummy:			; Dummy vector - there just to keep the assembler happy

	rti

***************************************************************************

**

** Ordered Table Search

**

**  X is pointing to the start of the first value in the table

**  tmp1:2 initially hold the start of table address, then they hold the bound values

**  tmp3 is the end of the table (nelements - 1)

**  tmp4 is the comparison value

**  tmp5 is the index result - if zero then comp value is less than beginning of table, and

**    if equal to nelements then it is rail-ed at upper end

**

***************************************************************************

ORD_TABLE_FIND:

        clr     tmp5

        ldhx    tmp1

        lda     ,x

        sta     tmp1

        sta     tmp2

;        cmp     tmp4

;        bhi     GOT_ORD_NUM

REENT:

        incx

        inc     tmp5

        mov     tmp2,tmp1

        lda     ,x

        sta     tmp2



        cmp     tmp4

        bhi     GOT_ORD_NUM

        lda     tmp5

        cmp     tmp3

        bne     REENT



;        inc     tmp5

;        mov     tmp2,tmp1

GOT_ORD_NUM:

        rts

********************************************************************************

********************************************************************************

*

*     32 x 16 Unsigned Divide

*

*     This routine takes the 32-bit dividend stored in INTACC1.....INTACC1+3

*     and divides it by the 16-bit divisor stored in INTACC2:INTACC2+1.

*     The quotient replaces the dividend and the remainder replaces the divisor.

*

UDVD32    EQU     *

*

DIVIDEND  EQU     INTACC1+2

DIVISOR   EQU     INTACC2

QUOTIENT  EQU     INTACC1

REMAINDER EQU     INTACC1

*

        PSHH                            ;save h-reg value

        PSHA                            ;save accumulator

        PSHX                            ;save x-reg value

        AIS     #-3                     ;reserve three bytes of temp storage

        LDA     #!32                    ;

        STA     3,SP                    ;loop counter for number of shifts

        LDA     DIVISOR                 ;get divisor msb

        STA     1,SP                    ;put divisor msb in working storage

        LDA     DIVISOR+1               ;get divisor lsb

        STA     2,SP                    ;put divisor lsb in working storage

*

*     Shift all four bytes of dividend 16 bits to the right and clear

*     both bytes of the temporary remainder location

*

        MOV     DIVIDEND+1,DIVIDEND+3   ;shift dividend lsb

        MOV     DIVIDEND,DIVIDEND+2     ;shift 2nd byte of dividend

        MOV     DIVIDEND-1,DIVIDEND+1   ;shift 3rd byte of dividend

        MOV     DIVIDEND-2,DIVIDEND     ;shift dividend msb

        CLR     REMAINDER               ;zero remainder msb

        CLR     REMAINDER+1             ;zero remainder lsb

*

*     Shift each byte of dividend and remainder one bit to the left

*

SHFTLP  LDA     REMAINDER               ;get remainder msb

        ROLA                            ;shift remainder msb into carry

        ROL     DIVIDEND+3              ;shift dividend lsb

        ROL     DIVIDEND+2              ;shift 2nd byte of dividend

        ROL     DIVIDEND+1              ;shift 3rd byte of dividend

        ROL     DIVIDEND                ;shift dividend msb

        ROL     REMAINDER+1             ;shift remainder lsb

        ROL     REMAINDER               ;shift remainder msb

*

*     Subtract both bytes of the divisor from the remainder

*

        LDA     REMAINDER+1             ;get remainder lsb

        SUB     2,SP                    ;subtract divisor lsb from remainder lsb

        STA     REMAINDER+1             ;store new remainder lsb

        LDA     REMAINDER               ;get remainder msb

        SBC     1,SP                    ;subtract divisor msb from remainder msb

        STA     REMAINDER               ;store new remainder msb

        LDA     DIVIDEND+3              ;get low byte of dividend/quotient

        SBC     #0                      ;dividend low bit holds subtract carry

        STA     DIVIDEND+3              ;store low byte of dividend/quotient

*

*     Check dividend/quotient lsb. If clear, set lsb of quotient to indicate

*     successful subraction, else add both bytes of divisor back to remainder

*

        BRCLR   0,DIVIDEND+3,SETLSB     ;check for a carry from subtraction

                                        ;and add divisor to remainder if set

        LDA     REMAINDER+1             ;get remainder lsb

        ADD     2,SP                    ;add divisor lsb to remainder lsb

        STA     REMAINDER+1             ;store remainder lsb

        LDA     REMAINDER               ;get remainder msb

        ADC     1,SP                    ;add divisor msb to remainder msb

        STA     REMAINDER               ;store remainder msb

        LDA     DIVIDEND+3              ;get low byte of dividend

        ADC     #0                      ;add carry to low bit of dividend

        STA     DIVIDEND+3              ;store low byte of dividend

        BRA     DECRMT                  ;do next shift and subtract



SETLSB  BSET    0,DIVIDEND+3            ;set lsb of quotient to indicate

                                        ;successive subtraction

DECRMT  DBNZ    3,SP,SHFTLP             ;decrement loop counter and do next

                                        ;shift

*

*     Move 32-bit dividend into INTACC1.....INTACC1+3 and put 16-bit

*     remainder in INTACC2:INTACC2+1

*

        LDA     REMAINDER               ;get remainder msb

        STA     1,SP                    ;temporarily store remainder msb

        LDA     REMAINDER+1             ;get remainder lsb

        STA     2,SP                    ;temporarily store remainder lsb

        MOV     DIVIDEND,QUOTIENT       ;

        MOV     DIVIDEND+1,QUOTIENT+1   ;shift all four bytes of quotient

        MOV     DIVIDEND+2,QUOTIENT+2   ; 16 bits to the left

        MOV     DIVIDEND+3,QUOTIENT+3   ;

        LDA     1,SP                    ;get final remainder msb

        STA     INTACC2                 ;store final remainder msb

        LDA     2,SP                    ;get final remainder lsb

        STA     INTACC2+1               ;store final remainder lsb

*

*     Deallocate local storage, restore register values, and return from

*     subroutine

*

        AIS     #3                      ;deallocate temporary storage

        PULX                            ;restore x-reg value

        PULA                            ;restore accumulator value

        PULH                            ;restore h-reg value

        RTS                             ;return

********************************************************************************


** FLASH Programming Routine

**  Copied into RAM and executed there

***************************************************************************



; Erase VE and Constants in FLASH - 128 byte erase

ERASE_N_BURN:

        lda       flocker

        cmp       #$CC

        beq       ERASE_CONT

        rts

ERASE_CONT:

        ldhx      #FLCR

        lda       #%00000010

        sta       ,x     ; Set erase bit

        lda       FLBPR  ; Read block protect register

        sta       VETABLE ; Write to any address in page to be erased

        lda       #$0C    ; Delay 10 us

        bsr       DELAYE

        lda       #%00001010

        sta       ,x      ; set HVEN

        lda       #$F0    ; 200 us

        bsr       DELAYE

        bsr       DELAYE

        bsr       DELAYE

        bsr       DELAYE

        bsr       DELAYE   ; total of 1 ms

        lda       #%00001000

        sta       ,x      ; clear erase bit

        lda       #$06

        bsr       DELAYE   ; 5 us

        lda       #$00000000

        sta       ,x      ; clear HVEN

        lda       #$02

        bsr       DELAYE

        bra       VE_BURNER



DELAYE:

        deca

        bne       DELAYE

        rts



; Now Burn VE (you can only freakin burn 64 bytes at a time)

VE_BURNER

        lda       #%00000001

        sta       ,x      ; Set PGM bit

        lda       FLBPR   ; read from FLASH block protect register

        sta       VETABLE ; wrte to any address within pgmed range

        lda       #$0C

        bsr       DELAYVE

        lda       #%00001001

        sta       ,x      ; HVEN set

        lda       #$06    ;

        bsr       DELAYVE   ; 5 us

        clrh

        clrx

LOOP_TO_BURN_VE:

        lda       VE,x

        sta       VETABLE,x

        lda       #$22     ; 28 us, everything else takes 2 us => 30 us total

        bsr       DELAYVE

        incx

        cpx       #$40

        beq       SD1

        bra       LOOP_TO_BURN_VE

SD1:

        ldhx      #FLCR

        lda       #%00001000

        sta       ,x

        lda       #$06

        bsr       DELAYVE

        lda       #%00000000

        sta       ,x

        lda       #$01

        bsr       DELAYVE

        bra       BURN_C

DELAYVE:

        deca

        bne       DELAYVE

        rts



; Now Burn COnstants

BURN_C:

        lda       #%00000001

        sta       ,x      ; Set PGM bit

        lda       FLBPR   ; read from FLASH block protect register

        sta       CWUTABLE ; wrte to any address within pgmed range

        lda       #$0C

        bsr       DELAYC

        lda       #%00001001

        sta       ,x      ; HVEN set

        lda       #$06    ;

        bsr       DELAYC   ; 5 us

        clrh

        clrx

LOOP_TO_BURN_C:

        lda       CWU,x

        sta       CWUTABLE,x

        lda       #$22     ; 28 us, everything else takes 2 us => 30 us total

        bsr       DELAYC

        incx

        cpx       #$40

        beq       SD2

        bra       LOOP_TO_BURN_C

SD2:

        ldhx      #FLCR

        lda       #%00001000

        sta       ,x

        lda       #$06

        bsr       DELAYC

        lda       #%00000000

        sta       ,x

        lda       #$01

        bsr       DELAYC

        rts                ; Exit from all of the burn routine

DELAYC:

        deca

        bne       DELAYC

        rts

DONE_C: rts





;--------------





        org     $FAC3   ; start of bootloader-defined jump table/vector

        db      $12     ; scbr regi init value

        db      %00000001 ; config1

        db      %00000001 ; config2

        dw      {rom_start + 128} ; megasquirt code start

        dw      $FB00    ; bootloader start



; Vector table

;	org	vec_timebase







        db      $CC

	dw	Dummy	;Timebase

        db      $CC

	dw	ADCDONE	;ADC Conversion Complete

        db      $CC

	dw	Dummy	;Keyboard pin

        db      $CC

	dw	IN_SCI_TX	;SCI transmission complete/transmitter empty

        db      $CC

	dw	IN_SCI_RCV	;SCI input idle/receiver full

        db      $CC

	dw	Dummy	;SCI parity/framing/noise/receiver_overrun error

        db      $CC

	dw	Dummy	;SPI Transmitter empty

        db      $CC

	dw	Dummy	;SPI mode/overflow/receiver full

        db      $CC

	dw	TIMERROLL	;TIM2 overflow

        db      $CC

	dw	Dummy	;TIM2 Ch1

        db      $CC

	dw	Dummy	;TIM2 Ch0

        db      $CC

	dw	Dummy	;TIM1 overflow

        db      $CC

	dw	Dummy	;TIM1 Ch1

        db      $CC

	dw	Dummy	;TIM Ch0

        db      $CC

	dw	Dummy	;CGM

        db      $CC

	dw	DOSQUIRT;IRQ

        db      $CC

	dw	Dummy	;SWI

        db      $CC

	dw	Start





; Lookup Tables

        org     $F100

     	include "barofactor4250.inc"

        include "kpafactor4250.inc"

        include "thermfactor.inc"

        include "airdenfactor.inc"



        org     $E000

; Initial VE table, copied into RAM at startup

VETABLE:

        db      39T     ; VE (0,0)

        db      40T     ; VE (0,1)

        db      41T     ; VE (0,2)

        db      44T     ; VE (0,3)

        db      44T     ; VE (0,4)

        db      44T     ; VE (0,5)

        db      45T     ; VE (0,6)

        db      45T     ; VE (0,7)

        db      47T     ; VE (1,0)

        db      47T     ; VE (1,1)

        db      51T     ; VE (1,2)

        db      51T     ; VE (1,3)

        db      50T     ; VE (1,4)

        db      50T     ; VE (1,5)

        db      50T     ; VE (1,6)

        db      50T     ; VE (1,7)

        db      52T     ; VE (2,0)

        db      55T     ; VE (2,1)

        db      55T     ; VE (2,2)

        db      57T     ; VE (2,3)

        db      60T     ; VE (2,4)

        db      61T     ; VE (2,5)

        db      61T     ; VE (2,6)

        db      65T     ; VE (2,7)

        db      59T     ; VE (3,0)

        db      60T     ; VE (3,1)

        db      60T     ; VE (3,2)

        db      65T     ; VE (3,3)

        db      66T     ; VE (3,4)

        db      70T     ; VE (3,5)

        db      70T     ; VE (3,6)

        db      70T     ; VE (3,7)

        db      61T     ; VE (4,0)

        db      63T     ; VE (4,1)

        db      65T     ; VE (4,2)

        db      65T     ; VE (4,3)

        db      68T     ; VE (4,4)

        db      70T     ; VE (4,5)

        db      72T     ; VE (4,6)

        db      75T     ; VE (4,7)

        db      65T     ; VE (5,0)

        db      72T     ; VE (5,1)

        db      72T     ; VE (5,2)

        db      74T     ; VE (5,3)

        db      74T     ; VE (5,4)

        db      75T     ; VE (5,5)

        db      75T     ; VE (5,6)

        db      77T     ; VE (5,7)

        db      70T     ; VE (6,0)

        db      74T     ; VE (6,1)

        db      74T     ; VE (6,2)

        db      75T     ; VE (6,3)

        db      75T     ; VE (6,4)

        db      77T     ; VE (6,5)

        db      77T     ; VE (6,6)

        db      78T     ; VE (6,7)

        db      75T     ; VE (7,0)

        db      77T     ; VE (7,1)

        db      79T     ; VE (7,2)

        db      82T     ; VE (7,3)

        db      82T     ; VE (7,4)

        db      82T     ; VE (7,5)

        db      82T     ; VE (7,6)

        db      85T     ; VE (7,7)

CWUTABLE:

        db      120T    ; CWU

        db      040T    ; CWH

        db      35T     ; AWEV

        db      250T    ; AWC

        db      180T    ; WWU (-40 F)

        db      180T    ; WWU (-20 F)

        db      160T    ; WWU (0 F)

        db      150T    ; WWU (20 F)

        db      135T    ; WWU (40 F)

        db      125T    ; WWU (60 F)

        db      113T    ; WWU (80 F)

        db      108T    ; WWU (100 F)

        db      102T    ; WWU (130 F)

        db      100T    ; WWU (160 F)

        db      20T      ; TPSAQ (tpsdot=0.1)

        db      50T      ; TPSAQ (tpsdot=0.4)

        db      105T      ; TPSAQ (tpsdot=0.8)

        db      150T     ; TPSAQ (tpsdot=1.5)

        db      90T     ; TPSACOLD (ms to add in when cold)

        db      03T     ; TPSTHRESH

        db      02T    ; TPSASYNC (accel enrich time in 1/10 second increments)

        db      100T    ; TPSDQ

        db      200T    ; EGOTEMP

        db      16T      ; EGOCOUNTCMP

        db      1T      ; EGODELTA

        db      15T     ; EGOLIMIT

        db      155T    ; REQFUEL

        db      4T      ; DIVIDER

        db      1T      ; Alternate

        db      10T     ; INJOPEN

        db      0T      ; INJOCFUEL

        db      75T    ; INJPWM

        db      255T    ; INJPWMT

        db      12T      ; BATTFAC

        db      $05     ; RPMK[0]

        db      $DC     ; RPMK[1]

RPMRANGEVEFLASH:

        db      5T      ; RPMRANGEVE[0]

        db      10T     ; RPMRANGEVE[1]

        db      15T     ; RPMRANGEVE[2]

        db      20T     ; RPMRANGEVE[3]

        db      28T     ; RPMRANGEVE[4]

        db      36T     ; RPMRANGEVE[5]

        db      44T     ; RPMRANGEVE[6]

        db      52T     ; RPMRANGEVE[7]

KPARANGEVEFLASH:

        db      20T     ; KPARANGEVE[0]

        db      30T     ; KPARANGEVE[1]

        db      40T     ; KPARANGEVE[2]

        db      50T     ; KPARANGEVE[3]

        db      60T     ; KPARANGEVE[4]

        db      75T     ; KPARANGEVE[5]

        db      90T     ; KPARANGEVE[6]

        db      100T    ; KPARANGEVE[7]

        db      113T    ; Config11

        db      112T    ; Config12

        db      00T     ; Config13

        db      20T     ; PRIMEP

        db      13T     ; RPMOXLIMIT

        db      185T    ; FAST IDLE TEMPERATURE

        db      26T     ; VOLTOXTARGET

        db      100T    ; ACCELMULT

        db      00T     ; BLANK[3]

        db      00T     ; BLANK[4]

        db      00T     ; BLANK[5]

        db      00T     ; BLANK[6]









; This is used to set the bin coolant range for WWU

WWURANGE:

        db      0T

        db      20T

        db      40T

        db      60T

        db      80T

        db      100T

        db      120T

        db      140T

        db      170T

        db      200T

tpsdotrate:

        db      05T     ; 0.1 volts delta

        db      20T     ; 0.4 volt delta

        db      40T     ; 0.8 volt

        db      77T     ; 1.5 volt



REVNUM: db      20T     ; Revision 2.986

Signature db 32T,' ** V2.986Embedded Code by B&G **'



        include "boot_r12.asm"



	end



